/*
 * Created on Aug 4, 2005
 *  
 * Copyright 2005 Tom Louton; Berlin, Germany, http://www.theloutons.com/photoalbumtom.htm 
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *       http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 */
package com.theloutons.search;

import java.awt.event.*;
import java.util.Properties;
import javax.swing.JFrame;
import javax.swing.WindowConstants;

import com.theloutons.search.userinterfaces.*;

/**
 * @author Tom Louton
 * 
 */
public class StartIndexerInterface {
	static Properties def = new Properties();
	/**
	 * 
	 * @param args all optional 
	 * args[0] index path, that is the path to which the index is written 
	 */
	public static void main(String[] args) {
		String indexPath = null;
		if (args.length>0) {
			indexPath=args[0];
		}
		String path = System.getProperty("user.dir") + "/data/indexer.defaults";

		JFrame choose = new UserIndexerInterface("Inexer Interface", path,indexPath);

		choose.setLocation(30, 30);
		choose.pack();
		choose.setVisible(true);

		choose.setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE);

		choose.addWindowListener(new WindowAdapter() {
			public void windowClosed(WindowEvent e) {
				System.exit(0);
			}
		});

	}
}
