/*
 * Created on Aug 29, 2005
 * Copyright 2005 Tom Louton; Berlin, Germany, http://www.theloutons.com/photoalbumtom.htm 
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *       http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * 
 * The concept here is to within the class create the document and read
 * the corresponding file and fill the document and return it or if 
 * something did not work, return null
 */
package com.theloutons.search.specialreaders;

import java.io.File;
import java.io.PrintWriter;
import org.apache.lucene.document.Document;

/**
 * @author Tom Louton
 * This is to define the way in which new file formats can be
 * added. 
 *
 */
public interface DocumentAnalyze {
    /**
     * The just returns the document created.
     * @return the lucene document with the text extracted from
     * the file f (below) was extracted.
     */
    Document getDocument();
    /**
     * This sets the files and does the extraction. Of course, one 
     * could use the getDocument to do the extraction too.
     * @param f the file from which the tokens are to be extracted.
     * @param log a log file. I suggest that where ever a doc=null;return
     * is done, write an reason to the log.
     */
    void setFile(File f,PrintWriter log);
}
