/*
 * Created on Aug 24, 2005
 *
 * Copyright 2005 Tom Louton; Berlin, Germany, http://www.theloutons.com/photoalbumtom.htm 
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *       http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package com.theloutons.search.utils;

import javax.swing.Action;
import javax.swing.Icon;
import javax.swing.JButton;

/**
 * @author sg00756 Tom This is a button with two boolean values to keep track of
 *         whether or not allow the button.
 */
public class ButtonwithToggle extends JButton {
    private boolean isIndexset = false;

    private boolean isSearchTextset = false;

    /**
     * create a blank button
     */
    public ButtonwithToggle() {
        super();
        setEnabled(false);
    }

    /**
     * @param text
     *            Create the buton with same text
     */
    public ButtonwithToggle(String text) {
        super(text);
        setEnabled(false);
    }

    /**
     * @param a
     *            create a button with an action
     */
    public ButtonwithToggle(Action a) {
        super(a);
        setEnabled(false);
    }

    /**
     * @param icon
     *            create a button with the icon
     */
    public ButtonwithToggle(Icon icon) {
        super(icon);
        setEnabled(false);
    }

    /**
     * create a button with text and icon
     * 
     * @param text
     *            Text for the button
     * @param icon
     *            and icon to be associated with it.
     */
    public ButtonwithToggle(String text, Icon icon) {
        super(text, icon);
        setEnabled(false);
    }

    /**
     * sets the boolean variable to true when the index is known.
     *  
     */
    public void indexKnown() {
        this.isIndexset = true;
        allow();
    }

    /**
     * If search text is set, the set the boolean to true
     *  
     */
    public void searchSet() {
        this.isSearchTextset = true;
        allow();
    }

    /**
     * if both booleans are true, then enable the button
     *  
     */
    public void allow() {
        if (this.isIndexset && this.isSearchTextset) {
            setEnabled(true);
        }
    }
}
