package com.theloutons.search.utils;

/*
 * Created on Apr 18, 2005
 * Copyright 2005 Tom Louton, Berlin, Germany, http://www.theloutons.com/photoalbumtom.htm 
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *       http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

/**
 * @author Tom Louton
 * This just is a trivial stop word manager for the indexer and searcher
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class StopWordMgmt {

	private String[] stopWords;
	/**
	 * 
	 */
	public StopWordMgmt() {
		super();
		this.stopWords=getDefault();
	}
	/**
	 * Creates with a list of stop words
	 * @param stops
	 */
	public StopWordMgmt(String[] stops) {
		this.stopWords=stops;
	}
	/**
	 * in case someone needs a list of stop words used, indexer etc.
	 * @return an array of the strings containing the stop words
	 */
	public String[] getStopWords() {
		return this.stopWords;
	}
	/**
	 * the default stop word list.
	 * @return an array of the strings containing the stop words
	 */
	public String[] getDefault() {
		return new String[] {
				"i",
				"me",
				"my",
				"myself",
				"we",
				"us",
				"our",
				"ours",
				"ourselves",
				"you",
				"your",
				"yours",
				"yourself",
				"yourselves",
				"he",
				"him",
				"his",
				"himself",
				"she",
				"her",
				"hers",
				"herself",
				"it",
				"its",
				"itself",
				"they",
				"them",
				"their",
				"theirs",
				"themselves",
				"what",
				"which",
				"who",
				"whom",
				"this",
				"that",
				"these",
				"those",
				"am",
				"is",
				"are",
				"was",
				"were",
				"be",
				"been",
				"being",
				"have",
				"has",
				"had",
				"having",
				"do",
				"does",
				"did",
				"doing",
				"will",
				"would",
				"shall",
				"should",
				"can",
				"could",
				"may",
				"might",
				"must",
				"ought",
				"a",
				"an",
				"the",
				"and",
				"but",
				"if",
				"or",
				"because",
				"as",
				"until",
				"while",
				"of",
				"at",
				"by",
				"for",
				"with",
				"about",
				"against",
				"between",
				"into",
				"through",
				"during",
				"before",
				"after",
				"above",
				"below",
				"to",
				"from",
				"up",
				"down",
				"in",
				"out",
				"on",
				"off",
				"over",
				"under",
				"again",
				"further",
				"then",
				"once",
				"here",
				"there",
				"when",
				"where",
				"why",
				"how",
				"all",
				"any",
				"both",
				"each",
				"few",
				"more",
				"most",
				"other",
				"some",
				"such",
				"no",
				"nor",
				"not",
				"only",
				"own",
				"same",
				"so",
				"than",
				"too",
				"very",
				"one",
				"every",
				"least",
				"less",
				"many",
				"now",
				"ever",
				"never",
				"say",
				"says",
				"said",
				"also",
				"get",
				"go",
				"goes",
				"just",
				"made",
				"make",
				"put",
				"see",
				"seen",
				"whether",
				"like",
				"well",
				"back",
				"even",
				"still",
				"way",
				"take",
				"since",
				"another",
				"however",
				"two",
				"three",
				"four",
				"five",
				"first",
				"second",
				"new",
				"old",
				"high",
				"long"
		};
	}
}
